<template>
    <div class="title row">
        <h1>Self Description</h1>
    </div>
            <div class="content row card-group">
                <div class="col">
                <div class="card">
                    <div class="card-title">
                <h1>Participants</h1>

                    </div>
                    <div class="text">
                <JsonTreeView :data="this.participants" />
            </div>
            </div>
        </div>
        <div class="col">
            <div class="card">
                <div class="card-title">
                    <h1>Service Offerings</h1>

                </div>
                <div class="card-content">
                    <JsonTreeView :data="this.serviceofferings" />

                </div>
            </div>
        </div>
        </div>

</template>




<style scoped>
.card-title {
    color: rgb(98, 98, 241);
}

#nav {
    padding: 0.1rem;
    text-align: center;
}

.card {
    width: auto;
    margin: 1rem;
    display: flex;
}
</style>
    
<script>
import axios from 'axios';
import { JsonTreeView } from "json-tree-view-vue3";


export default {
    name: 'SelfDescription',
    data() {
        return {
            participants: JSON.stringify({ "msg": 'No message yet' }),
            serviceofferings: JSON.stringify({ "msg": 'No message yet' })
        };
    },
    components: { JsonTreeView },
    props: {
        name: {
            type: String,
            required: true
        }
    },

    methods: {
        getMessage() {
            console.log(this.name)
            const path = 'http://localhost:5001/product/test?identifier=urn:aas:techx:asset:Roller-0000';
            axios.get(path)
                .then((res) => {
                    let resp = res.data;
                    for (let i in resp["full_version"]["selfdescriptions"]["participants"]) {
                        if (resp["full_version"]["selfdescriptions"]["participants"][i]["selfDescriptionCredential"]["verifiableCredential"][0]["id"].includes(this.name)) {
                            this.participants = JSON.stringify(resp["full_version"]["selfdescriptions"]["participants"][i])
                            
                        }
                    }
                    for (let i in resp["full_version"]["selfdescriptions"]["phases"]) {
                        if (resp["full_version"]["selfdescriptions"]["phases"][i]["selfDescriptionCredential"]["id"].includes(this.name)) {
                            this.serviceofferings = JSON.stringify(resp["full_version"]["selfdescriptions"]["phases"][i])
                        }
                    }
                })
                .catch((error) => {

                    console.error(error);
                });
        },
    },
    created() {
        this.getMessage();
    },
};
</script>